HDU3466

来源:互联网 发布:淘宝男士内衣薄款莱卡 编辑:程序博客网 时间:2024/06/05 20:28

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3466

Proud Merchants

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 5025    Accepted Submission(s): 2110


Problem Description
Recently, iSea went to an ancient country. For such a long time, it was the most wealthy and powerful kingdom in the world. As a result, the people in this country are still very proud even if their nation hasn’t been so wealthy any more.
The merchants were the most typical, each of them only sold exactly one item, the price was Pi, but they would refuse to make a trade with you if your money were less than Qi, and iSea evaluated every item a value Vi.
If he had M units of money, what’s the maximum value iSea could get?

 

Input
There are several test cases in the input.

Each test case begin with two integers N, M (1 ≤ N ≤ 500, 1 ≤ M ≤ 5000), indicating the items’ number and the initial money.
Then N lines follow, each line contains three numbers Pi, Qi and Vi (1 ≤ Pi ≤ Qi ≤ 100, 1 ≤ Vi ≤ 1000), their meaning is in the description.

The input terminates by end of file marker.

 

Output
For each test case, output one integer, indicating maximum value iSea could get.

 

Sample Input
2 1010 15 105 10 53 105 10 53 5 62 7 3
 

Sample Output
511
解题思路:因为这道题不光对总钱数有限制,而且每样东西都有一个价钱,以及买这个东西最少拥有的钱数,就像如果一个物品是5 9,一个物品是5 6,对第一个进行背包的时候只有dp[9],dp[10],…,dp[m],再对第二个进行背包的时候,如果是普通的,应该会借用前面的dp[8],dp[7]之类的,但是现在这些值都是0,所以会导致结果出错。于是要想到只有后面要用的值前面都可以得到,那么才不会出错。设A:p1,q1 B:p2,q2,如果先A后B,则至少需要p1+q2的容量,如果先B后A,至少需要p2+q1的容量,那么就是p1+q2 > p2+q1,变形之后就是q1-p1 < q2-p2。具体看代码中的排序部分

#include<cstdio>#include<iostream>#include<cstring>#include<algorithm>using namespace std;struct Node{    int p;    int q;    int v;}node[510];int dp[5010];///用 i 钱能得到的最大价值int cmp(Node a, Node b)///按q-p排序,保证差额最小为最优 {    return a.q-a.p < b.q-b.p;}int main(){    int n,m;    while(scanf("%d%d",&n,&m)!=EOF)    {        for(int i=1;i<=n;i++)        {            scanf("%d%d%d", &node[i].p, &node[i].q, &node[i].v);        }        memset(dp,0,sizeof(dp));        sort(node+1,node+n+1,cmp);        for(int i=1;i<=n;i++)        {            for(int j=m;j>=node[i].q;j--)            {                dp[j]=max(dp[j],dp[j-node[i].p]+node[i].v);            }        }        printf("%d\n",dp[m]);    }    return 0;}


0 0
原创粉丝点击